From 38c955444cdd8ed876aaf7f635afc0a0a6055b54 Mon Sep 17 00:00:00 2001
From: Niklas Haas <git@haasn.dev>
Date: Wed, 13 Aug 2025 15:29:32 +0200
Subject: [PATCH 31/37] avfilter/vf_fade: set correct alpha mode requirement

Fading to black in non-alpha mode works for either straight or premultiplied
alpha, but fading to a color does not.
---
 libavfilter/vf_fade.c | 19 ++++++++++++++++++-
 1 file changed, 18 insertions(+), 1 deletion(-)

diff --git a/libavfilter/vf_fade.c b/libavfilter/vf_fade.c
index 69198ea1d1..794586af07 100644
--- a/libavfilter/vf_fade.c
+++ b/libavfilter/vf_fade.c
@@ -151,19 +151,36 @@ static int query_formats(const AVFilterContext *ctx,
         AV_PIX_FMT_GBRAP,
         AV_PIX_FMT_NONE
     };
+    const static int straight_alpha[] = {
+        AVALPHA_MODE_UNSPECIFIED,
+        AVALPHA_MODE_STRAIGHT,
+        -1,
+    };
     const enum AVPixelFormat *pixel_fmts;
+    int need_straight = 0;
+    int ret;
 
     if (s->alpha) {
         if (s->black_fade)
             pixel_fmts = pix_fmts_alpha;
         else
             pixel_fmts = pix_fmts_rgba;
+        need_straight = 1;
     } else {
         if (s->black_fade)
             pixel_fmts = pix_fmts;
-        else
+        else {
             pixel_fmts = pix_fmts_rgb;
+            need_straight = 1;
+        }
     }
+
+    if (need_straight) {
+        ret = ff_set_common_alpha_modes_from_list2(ctx, cfg_in, cfg_out, straight_alpha);
+        if (ret < 0)
+            return ret;
+    }
+
     return ff_set_common_formats_from_list2(ctx, cfg_in, cfg_out, pixel_fmts);
 }
 
-- 
2.49.1


